/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.LineProbe;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import org.visnow.jscic.Field;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.mappers.LineProbe.LineProbeShared.*;
import org.visnow.vn.lib.utils.graphing.GraphParams;
import static org.visnow.vn.lib.utils.interpolation.SubsetGeometryComponents.LINE_SLICE_COORDS;
import static org.visnow.vn.lib.utils.probeInterfaces.ProbeDisplay.Position.*;

public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;
    private GraphParams graphParams;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public GUI()
    {
        initComponents();
        positionCombo.setSelectedIndex(1);
        graphGUI.setMultiGraphGUI(multiGraphPanel);
        graphGUI.hideTitleGUI();
        legendPositionPanel.setVisible(false);
    }
    
    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }
    
    public void setGraphParams(GraphParams graphParams)
    {
        graphGUI.setParams(graphParams);
        this.graphParams = graphParams;
    }
    
    public void  setGraphedField(Field inField)
    {
        graphGUI.setInField(inField);
        graphGUI.requestArgument(LINE_SLICE_COORDS);
    }
    
    void updateGUI(ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup = new javax.swing.ButtonGroup();
        buttonGroup1 = new javax.swing.ButtonGroup();
        multiGraphPanel = new javax.swing.JPanel();
        positionCombo = new javax.swing.JComboBox<>();
        pointerLinesButton = new javax.swing.JRadioButton();
        sliceNumbersButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        initMarginSlider = new javax.swing.JSlider();
        jLabel2 = new javax.swing.JLabel();
        graphHeightSlider = new javax.swing.JSlider();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        graphWidthSlider = new javax.swing.JSlider();
        jPanel3 = new javax.swing.JPanel();
        resetButton = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        gapSlider = new javax.swing.JSlider();
        legendPositionPanel = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        colorLegendXSlider = new javax.swing.JSlider();
        jLabel8 = new javax.swing.JLabel();
        colorLegendYSlider = new javax.swing.JSlider();
        probeGraphsPanel = new javax.swing.JPanel();
        graphGUI = new org.visnow.vn.lib.utils.graphing.GUI();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        probePane = new javax.swing.JPanel();
        glyphControlPanel = new javax.swing.JPanel();
        indexProbePanel = new javax.swing.JPanel();
        geomProbePanel = new javax.swing.JPanel();
        probeTypePanel = new javax.swing.JPanel();
        geomProbeSelector = new javax.swing.JRadioButton();
        indexProbeSelector = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        sliceAddButton = new javax.swing.JButton();
        sliceRemoveButton = new javax.swing.JButton();
        slicesClearButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        currentGraphTitleField = new javax.swing.JTextField();

        multiGraphPanel.setLayout(new java.awt.GridBagLayout());

        positionCombo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "top", "right", "bottom", "left", "at point" }));
        positionCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                positionComboItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(8, 14, 8, 0);
        multiGraphPanel.add(positionCombo, gridBagConstraints);

        buttonGroup.add(pointerLinesButton);
        pointerLinesButton.setSelected(true);
        pointerLinesButton.setText("pointer lines"); // NOI18N
        pointerLinesButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                pointerLinesButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        multiGraphPanel.add(pointerLinesButton, gridBagConstraints);

        buttonGroup.add(sliceNumbersButton);
        sliceNumbersButton.setText("probe numbers"); // NOI18N
        sliceNumbersButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceNumbersButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 0);
        multiGraphPanel.add(sliceNumbersButton, gridBagConstraints);

        jLabel1.setText("graphs position"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 3);
        multiGraphPanel.add(jLabel1, gridBagConstraints);

        initMarginSlider.setMajorTickSpacing(20);
        initMarginSlider.setPaintTicks(true);
        initMarginSlider.setValue(0);
        initMarginSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                initMarginSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 11, 5, 0);
        multiGraphPanel.add(initMarginSlider, gridBagConstraints);

        jLabel2.setText("initial margin"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        multiGraphPanel.add(jLabel2, gridBagConstraints);

        graphHeightSlider.setMajorTickSpacing(20);
        graphHeightSlider.setMinorTickSpacing(5);
        graphHeightSlider.setPaintTicks(true);
        graphHeightSlider.setValue(20);
        graphHeightSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                graphHeightSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 11, 5, 0);
        multiGraphPanel.add(graphHeightSlider, gridBagConstraints);

        jLabel3.setText("graph width"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        multiGraphPanel.add(jLabel3, gridBagConstraints);

        jLabel4.setText("graph height"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        multiGraphPanel.add(jLabel4, gridBagConstraints);

        graphWidthSlider.setMajorTickSpacing(20);
        graphWidthSlider.setMinorTickSpacing(5);
        graphWidthSlider.setPaintTicks(true);
        graphWidthSlider.setValue(20);
        graphWidthSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                graphWidthSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 11, 5, 0);
        multiGraphPanel.add(graphWidthSlider, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        multiGraphPanel.add(jPanel3, gridBagConstraints);

        resetButton.setText("reset graph dimensions"); // NOI18N
        resetButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                resetButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        multiGraphPanel.add(resetButton, gridBagConstraints);

        jLabel5.setText("<html>gap between<p> graphs</html>"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.weightx = 1.0;
        multiGraphPanel.add(jLabel5, gridBagConstraints);

        gapSlider.setMajorTickSpacing(10);
        gapSlider.setMaximum(50);
        gapSlider.setMinorTickSpacing(2);
        gapSlider.setPaintTicks(true);
        gapSlider.setValue(1);
        gapSlider.setAutoscrolls(true);
        gapSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                gapSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 11, 5, 0);
        multiGraphPanel.add(gapSlider, gridBagConstraints);

        legendPositionPanel.setLayout(new java.awt.GridBagLayout());

        jLabel7.setText("color legend x");
        legendPositionPanel.add(jLabel7, new java.awt.GridBagConstraints());

        colorLegendXSlider.setMajorTickSpacing(5);
        colorLegendXSlider.setPaintTicks(true);
        colorLegendXSlider.setValue(100);
        colorLegendXSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                colorLegendXSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 8, 8);
        legendPositionPanel.add(colorLegendXSlider, gridBagConstraints);

        jLabel8.setText("color legend y");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        legendPositionPanel.add(jLabel8, gridBagConstraints);

        colorLegendYSlider.setMajorTickSpacing(5);
        colorLegendYSlider.setPaintTicks(true);
        colorLegendYSlider.setValue(100);
        colorLegendYSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                colorLegendYSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 8, 8);
        legendPositionPanel.add(colorLegendYSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(7, 7, 7, 7);
        multiGraphPanel.add(legendPositionPanel, gridBagConstraints);

        probeGraphsPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        probeGraphsPanel.add(graphGUI, gridBagConstraints);

        setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);

        probePane.setLayout(new java.awt.GridBagLayout());

        glyphControlPanel.setMinimumSize(new java.awt.Dimension(180, 370));
        glyphControlPanel.setPreferredSize(new java.awt.Dimension(250, 400));
        glyphControlPanel.setLayout(new java.awt.GridBagLayout());

        indexProbePanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        glyphControlPanel.add(indexProbePanel, gridBagConstraints);

        geomProbePanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        glyphControlPanel.add(geomProbePanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        probePane.add(glyphControlPanel, gridBagConstraints);

        probeTypePanel.setLayout(new java.awt.GridLayout(1, 0));

        buttonGroup1.add(geomProbeSelector);
        geomProbeSelector.setSelected(true);
        geomProbeSelector.setText("geometric"); // NOI18N
        geomProbeSelector.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                geomProbeSelectorActionPerformed(evt);
            }
        });
        probeTypePanel.add(geomProbeSelector);

        buttonGroup1.add(indexProbeSelector);
        indexProbeSelector.setText("by index"); // NOI18N
        indexProbeSelector.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                indexProbeSelectorActionPerformed(evt);
            }
        });
        probeTypePanel.add(indexProbeSelector);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        probePane.add(probeTypePanel, gridBagConstraints);

        jPanel5.setLayout(new java.awt.GridLayout(3, 0));

        sliceAddButton.setText("add current probe"); // NOI18N
        sliceAddButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceAddButtonActionPerformed(evt);
            }
        });
        jPanel5.add(sliceAddButton);

        sliceRemoveButton.setText("remove selected probe"); // NOI18N
        sliceRemoveButton.setToolTipText("click graph to select corresponding probe"); // NOI18N
        sliceRemoveButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceRemoveButtonActionPerformed(evt);
            }
        });
        jPanel5.add(sliceRemoveButton);

        slicesClearButton.setText("clear all probes"); // NOI18N
        slicesClearButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                slicesClearButtonActionPerformed(evt);
            }
        });
        jPanel5.add(slicesClearButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 27, 0);
        probePane.add(jPanel5, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        probePane.add(jPanel1, gridBagConstraints);

        currentGraphTitleField.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        currentGraphTitleField.setBorder(javax.swing.BorderFactory.createTitledBorder("graph title"));
        currentGraphTitleField.setMinimumSize(new java.awt.Dimension(10, 40));
        currentGraphTitleField.setPreferredSize(new java.awt.Dimension(10, 45));
        currentGraphTitleField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                currentGraphTitleFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        probePane.add(currentGraphTitleField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(probePane, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    
    private void sliceAddButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_sliceAddButtonActionPerformed
    {//GEN-HEADEREND:event_sliceAddButtonActionPerformed
        if (parameters == null)
            return;
        parameters.set(ADD_SLICE, true);
    }//GEN-LAST:event_sliceAddButtonActionPerformed

    private void slicesClearButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_slicesClearButtonActionPerformed
    {//GEN-HEADEREND:event_slicesClearButtonActionPerformed
        if (parameters == null)
            return;
        parameters.set(CLEAR_SLICES, true);
    }//GEN-LAST:event_slicesClearButtonActionPerformed

    private void positionComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_positionComboItemStateChanged
    {//GEN-HEADEREND:event_positionComboItemStateChanged
        if (parameters == null)
            return;
        switch (positionCombo.getSelectedIndex()) {
            case 0:
                parameters.set(GRAPHS_POSITION, TOP);
                break;
            case 1:
                parameters.set(GRAPHS_POSITION, RIGHT);
                break;
            case 2:
                parameters.set(GRAPHS_POSITION, BOTTOM);
                break;
            case 3:
                parameters.set(GRAPHS_POSITION, LEFT);
                break;
            case 4:
                parameters.set(GRAPHS_POSITION, AT_POINT);
                break;
        }
        legendPositionPanel.setVisible(parameters.get(GRAPHS_POSITION) == AT_POINT);
    }//GEN-LAST:event_positionComboItemStateChanged

    private void sliceRemoveButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_sliceRemoveButtonActionPerformed
    {//GEN-HEADEREND:event_sliceRemoveButtonActionPerformed
       if (parameters == null)
            return;
       parameters.set(DEL_SLICE, true);
    }//GEN-LAST:event_sliceRemoveButtonActionPerformed

    private void pointerLinesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pointerLinesButtonActionPerformed
        if (parameters == null)
            return;
        parameters.set(POINTER_LINE, pointerLinesButton.isSelected());
    }//GEN-LAST:event_pointerLinesButtonActionPerformed

    private void sliceNumbersButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sliceNumbersButtonActionPerformed
        if (parameters == null)
            return;
        parameters.set(POINTER_LINE, pointerLinesButton.isSelected());
    }//GEN-LAST:event_sliceNumbersButtonActionPerformed

    private void indexProbeSelectorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_indexProbeSelectorActionPerformed
        if (parameters == null)
            return;
        parameters.set(PROBE_TYPE, geomProbeSelector.isSelected() ? ProbeType.GEOMETRIC : ProbeType.INDEX);
        updateGlyphControlPanel();
    }//GEN-LAST:event_indexProbeSelectorActionPerformed

    private void geomProbeSelectorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_geomProbeSelectorActionPerformed
        if (parameters == null)
            return;
        parameters.set(PROBE_TYPE, geomProbeSelector.isSelected() ? ProbeType.GEOMETRIC : ProbeType.INDEX);
        updateGlyphControlPanel();
    }//GEN-LAST:event_geomProbeSelectorActionPerformed

    private void initMarginSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_initMarginSliderStateChanged
        if (!initMarginSlider.getValueIsAdjusting())
            parameters.set(INIT_MARGIN, initMarginSlider.getValue());
    }//GEN-LAST:event_initMarginSliderStateChanged

    private void graphWidthSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_graphWidthSliderStateChanged
    {//GEN-HEADEREND:event_graphWidthSliderStateChanged
        if (!graphWidthSlider.getValueIsAdjusting() && graphParams != null)
            graphParams.setGraphWidth(graphWidthSlider.getValue() / 100f);
            
    }//GEN-LAST:event_graphWidthSliderStateChanged

    private void graphHeightSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_graphHeightSliderStateChanged
    {//GEN-HEADEREND:event_graphHeightSliderStateChanged
        if (!graphHeightSlider.getValueIsAdjusting() && graphParams != null)
            graphParams.setGraphHeight(graphHeightSlider.getValue() / 100f);
    }//GEN-LAST:event_graphHeightSliderStateChanged

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_resetButtonActionPerformed
    {//GEN-HEADEREND:event_resetButtonActionPerformed
        graphParams.setActive(false);
        graphWidthSlider.setValue(20);
        graphParams.setGraphWidth(.2f);
        graphHeightSlider.setValue(20);
        graphParams.setGraphHeight(.2f);
        initMarginSlider.setValue(5);
        gapSlider.setValue(10);
        parameters.set(INIT_MARGIN, initMarginSlider.getValue());
        graphParams.setActive(true);
    }//GEN-LAST:event_resetButtonActionPerformed

    private void gapSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_gapSliderStateChanged
    {//GEN-HEADEREND:event_gapSliderStateChanged
        parameters.set(GAP, gapSlider.getValue());
    }//GEN-LAST:event_gapSliderStateChanged

    private void currentGraphTitleFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_currentGraphTitleFieldActionPerformed
        parameters.set(GRAPH_TITLE,currentGraphTitleField.getText());
    }//GEN-LAST:event_currentGraphTitleFieldActionPerformed

    private void colorLegendXSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_colorLegendXSliderStateChanged
    {//GEN-HEADEREND:event_colorLegendXSliderStateChanged
        if (graphParams != null)
            graphParams.setLegendXPosition(colorLegendXSlider.getValue() /100f);
    }//GEN-LAST:event_colorLegendXSliderStateChanged

    private void colorLegendYSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_colorLegendYSliderStateChanged
    {//GEN-HEADEREND:event_colorLegendYSliderStateChanged
        if (graphParams != null)
            graphParams.setLegendYPosition(colorLegendYSlider.getValue() /100f);
    }//GEN-LAST:event_colorLegendYSliderStateChanged
    
    public void setProbePanels(JPanel geomPanel, JPanel indexPanel)
    {
        parameters.setActive(false);
        parameters.setParameterActive(false);
        geomProbePanel.removeAll();
        indexProbePanel.removeAll();
        if (indexPanel != null) {
            indexProbePanel.add(indexPanel, BorderLayout.CENTER);
            indexProbeSelector.setEnabled(indexPanel != null);
        }
        if (geomPanel != null) {
            geomProbePanel.add(geomPanel, BorderLayout.CENTER);
            geomProbeSelector.setEnabled(geomPanel != null);
            geomProbeSelector.setSelected(true);
            parameters.set(PROBE_TYPE, ProbeType.GEOMETRIC);
        }
        else {
            indexProbeSelector.setSelected(true);
            parameters.set(PROBE_TYPE, ProbeType.INDEX);
        }
        updateGlyphControlPanel();
        probeTypePanel.setVisible(geomPanel != null && indexPanel != null);
        parameters.setParameterActive(true);
        parameters.setActive(true);
    }
    
    private void updateGlyphControlPanel()
    {
        boolean geom = parameters.get(PROBE_TYPE) == ProbeType.GEOMETRIC;
        geomProbePanel.setVisible(geom);
        indexProbePanel.setVisible(!geom);
    }

    public JPanel getProbeGraphsPanel() {
        return probeGraphsPanel;
    }
    
    public void enableRemoveGraph(boolean enable)
    {
        sliceRemoveButton.setEnabled(enable);
    }

    public void enableAddGraph(boolean enable)
    {
        sliceAddButton.setEnabled(enable);
    }
    
    public void showGraphTitle(String s)
    {
        currentGraphTitleField.setText(s);
    }

    public org.visnow.vn.lib.utils.graphing.GUI getGraphGUI()
    {
        return graphGUI;
    }
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JSlider colorLegendXSlider;
    private javax.swing.JSlider colorLegendYSlider;
    private javax.swing.JTextField currentGraphTitleField;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JSlider gapSlider;
    private javax.swing.JPanel geomProbePanel;
    private javax.swing.JRadioButton geomProbeSelector;
    private javax.swing.JPanel glyphControlPanel;
    private org.visnow.vn.lib.utils.graphing.GUI graphGUI;
    private javax.swing.JSlider graphHeightSlider;
    private javax.swing.JSlider graphWidthSlider;
    private javax.swing.JPanel indexProbePanel;
    private javax.swing.JRadioButton indexProbeSelector;
    private javax.swing.JSlider initMarginSlider;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel legendPositionPanel;
    private javax.swing.JPanel multiGraphPanel;
    private javax.swing.JRadioButton pointerLinesButton;
    private javax.swing.JComboBox<String> positionCombo;
    private javax.swing.JPanel probeGraphsPanel;
    private javax.swing.JPanel probePane;
    private javax.swing.JPanel probeTypePanel;
    private javax.swing.JButton resetButton;
    private javax.swing.JButton sliceAddButton;
    private javax.swing.JRadioButton sliceNumbersButton;
    private javax.swing.JButton sliceRemoveButton;
    private javax.swing.JButton slicesClearButton;
    // End of variables declaration//GEN-END:variables

}
